libstdc++: __gnu_debug::_Safe_iterator_base Class Reference

libstdc++

__gnu_debug::_Safe_iterator_base Class Reference

`#include <safe_base.h>`

Inheritance diagram for __gnu_debug::_Safe_iterator_base:
[legend]

## Public Member Functions
bool | _M_attached_to (const _Safe_sequence_base *__seq) const
bool | _M_can_compare (const _Safe_iterator_base &__x) const noexcept
void | _M_detach_single () noexcept
void | _M_invalidate ()
void | _M_reset () noexcept
bool | _M_singular () const noexcept
void | _M_unlink () noexcept

## Public Attributes
_Safe_iterator_base * | _M_next
_Safe_iterator_base * | _M_prior
const _Safe_sequence_base * | _M_sequence
unsigned int | _M_version

## Protected Member Functions
constexpr | _Safe_iterator_base ()
constexpr | _Safe_iterator_base (const _Safe_iterator_base &__x, bool __constant)
constexpr | _Safe_iterator_base (const _Safe_sequence_base *__seq, bool __constant)
void | _M_attach (const _Safe_sequence_base *__seq, bool __constant)
void | _M_attach_single (const _Safe_sequence_base *__seq, bool __constant) noexcept
void | _M_detach ()
__gnu_cxx::__mutex & | _M_get_mutex () noexcept

## Friends
class | _Safe_sequence_base

## Detailed Description

Basic functionality for a safe iterator.

The _Safe_iterator_base base class implements the functionality of a safe iterator that is not specific to a particular iterator type. It contains a pointer back to the sequence it references along with iterator version information and pointers to form a doubly-linked list of iterators referenced by the container.

This class must not perform any operations that can throw an exception, or the exception guarantees of derived iterators will be broken.

Definition at line 50 of file safe_base.h.

## Constructor & Destructor Documentation

## ◆ _Safe_iterator_base() [1/3]

__gnu_debug::_Safe_iterator_base::_Safe_iterator_base | ( |  | ) |
| inlineconstexprprotected

Initializes the iterator and makes it singular.

Definition at line 81 of file safe_base.h.

References _M_next, _M_prior, _M_sequence, and _M_version.

Referenced by _Safe_iterator_base(), and _M_can_compare().

## ◆ _Safe_iterator_base() [2/3]

__gnu_debug::_Safe_iterator_base::_Safe_iterator_base | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )
| inlineconstexprprotected

Initialize the iterator to reference the sequence pointed to by `__seq`. `__constant` is true when we are initializing a constant iterator, and false if it is a mutable iterator. Note that `__seq` may be NULL, in which case the iterator will be singular. Otherwise, the iterator will reference `__seq` and be nonsingular.

Definition at line 93 of file safe_base.h.

References _M_attach(), _M_next, _M_prior, _M_sequence, and _M_version.

## ◆ _Safe_iterator_base() [3/3]

__gnu_debug::_Safe_iterator_base::_Safe_iterator_base | ( | const _Safe_iterator_base & | __x,
|  | bool | __constant )
| inlineconstexprprotected

Initializes the iterator to reference the same sequence that `__x` does. `__constant` is true if this is a constant iterator, and false if it is mutable.

Definition at line 104 of file safe_base.h.

References _Safe_iterator_base(), _M_attach(), _M_next, _M_prior, _M_sequence, and _M_version.

## ◆ ~_Safe_iterator_base()

__gnu_debug::_Safe_iterator_base::~_Safe_iterator_base | ( |  | ) |
| inlineconstexprprotected

Definition at line 112 of file safe_base.h.

## Member Function Documentation

## ◆ _M_attach()

void __gnu_debug::_Safe_iterator_base::_M_attach | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )
| protected

Attaches this iterator to the given sequence, detaching it from whatever sequence it was attached to originally. If the new sequence is the NULL pointer, the iterator is left unattached.

References _M_attach().

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach(), and _M_attach().

## ◆ _M_attach_single()

void __gnu_debug::_Safe_iterator_base::_M_attach_single | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )
| protectednoexcept

Likewise, but not thread-safe.

References _M_attach_single().

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach_single(), and _M_attach_single().

## ◆ _M_attached_to()

bool __gnu_debug::_Safe_iterator_base::_M_attached_to | ( | const _Safe_sequence_base * | __seq | ) | const
| inline

Determines if we are attached to the given sequence.

Definition at line 161 of file safe_base.h.

References _M_attached_to(), and _M_sequence.

Referenced by _M_attached_to().

## ◆ _M_can_compare()

bool __gnu_debug::_Safe_iterator_base::_M_can_compare | ( | const _Safe_iterator_base & | __x | ) | const
| noexcept

Can we compare this iterator to the given iterator `__x`? Returns true if both iterators are nonsingular and reference the same sequence.

References _Safe_iterator_base(), and _M_can_compare().

Referenced by _M_can_compare().

## ◆ _M_detach()

void __gnu_debug::_Safe_iterator_base::_M_detach | ( |  | ) |
| protected

Detach the iterator for whatever sequence it is attached to, if any.

References _M_detach().

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), _M_detach(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), and __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=().

## ◆ _M_detach_single()

void __gnu_debug::_Safe_iterator_base::_M_detach_single | ( |  | ) |
| noexcept

Likewise, but not thread-safe.

## ◆ _M_get_mutex()

__gnu_cxx::__mutex & __gnu_debug::_Safe_iterator_base::_M_get_mutex | ( |  | ) |
| protectednoexcept

For use in _Safe_iterator.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator++(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator++(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_invalidate()

void __gnu_debug::_Safe_iterator_base::_M_invalidate | ( |  | ) |
| inline

Invalidate the iterator, making it singular.

Definition at line 176 of file safe_base.h.

References _M_invalidate(), and _M_version.

Referenced by _M_invalidate().

## ◆ _M_reset()

void __gnu_debug::_Safe_iterator_base::_M_reset | ( |  | ) |
| noexcept

Reset all member variables

## ◆ _M_singular()

bool __gnu_debug::_Safe_iterator_base::_M_singular | ( |  | ) | const
| noexcept

Is this iterator singular?

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::__check_singular_aux(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_dereferenceable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_dereferenceable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_incrementable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_incrementable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_unlink()

void __gnu_debug::_Safe_iterator_base::_M_unlink | ( |  | ) |
| inlinenoexcept

Unlink itself

Definition at line 185 of file safe_base.h.

References _M_next, _M_prior, and _M_unlink().

Referenced by _M_unlink().

## Friends And Related Symbol Documentation

## ◆ _Safe_sequence_base

friend class _Safe_sequence_base
| friend

Definition at line 52 of file safe_base.h.

## Member Data Documentation

## ◆ _M_next

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_next

Pointer to the next iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 76 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## ◆ _M_prior

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_prior

Pointer to the previous iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 72 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## ◆ _M_sequence

const _Safe_sequence_base* __gnu_debug::_Safe_iterator_base::_M_sequence

The sequence this iterator references; may be NULL to indicate a singular iterator. Stored as pointer-to-const because sequence could be declared as const.

Definition at line 59 of file safe_base.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_attached_to(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_version

unsigned int __gnu_debug::_Safe_iterator_base::_M_version

The version number of this iterator. The sentinel value 0 is used to indicate an invalidated iterator (i.e., one that is singular because of an operation on the container). This version number must equal the version number in the sequence referenced by _M_sequence for the iterator to be non-singular.

Definition at line 68 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_invalidate(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

The documentation for this class was generated from the following file:

- safe_base.h